//
// This is a part of e-sushi module sourcecode
// for Litestep, a replacement shell.
// Copyright (C) 2002 Mike Edward Moras / e-sushi
//
// This program is free software;
// you can redistribute it and/or modify it under
// the terms of the GNU General Public License
// as published by the Free Software Foundation;
// either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it
// will be useful, but WITHOUT ANY WARRANTY; without
// even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the
// GNU General Public License along with this program;
// if not, write to: Free Software Foundation, Inc.
//                   59 Temple Place - Suite 330
//                   Boston
//                   MA  02111-1307, USA.
//

/*

  25jun02 / e-sushi / M.E.Moras
----------------------------------------------------------
  - re-arranged idea of module handling

  miniwallimgpath  ;the path to the BMP you want to use.
                 "$themesdir$sample.bmp" works too ;)
  
  miniwalldllpath  ;the path to the BMP you want to use.
                 "$themesdir$sample.bmp" works too ;)

  miniwallc     ;this is a bool, if it's there,
                 the wallpaper is centered
  miniwalls     ;this is a bool, if it's there,
                 the wallpaper is streched
  miniwallt     ;this is a bool, if it's there,
                 the wallpaper is tiled

  miniwallstop     ;this is a bool, if it's there,
				no wallpaper is loaded ;)

  24jun02 / e-sushi / M.E.Moras
----------------------------------------------------------
	got sick and tired of using freaking modules loaded
	with tons of stuff while all I need is a module that
	allows me to auto-set a wallpaper on load.

  miniwalluse	;this is a bool, if it's there,
				 the wallpaper will be set!
  miniwallimgpath  ;the path to the BMP you want to use.
                 "$themesdir$sample.bmp" works too ;)
  miniwalldllpath  ;the path to the BMP you want to use.
                 "$themesdir$sample.bmp" works too ;)
  miniwallc     ;this is a bool, if it's there,
                 the wallpaper is centered
  miniwalls     ;this is a bool, if it's there,
                 the wallpaper is streched
  miniwallt     ;this is a bool, if it's there,
                 the wallpaper is tiled
*/

#define WIN32_LEAN_AND_MEAN
#include "../lsapi/lsapi.h"



extern "C" {
    __declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
    __declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

int initModuleEx(HWND parentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
    int code = 0;
	
	char mybitmap[MAX_PATH];
	char mytmppath[MAX_PATH], mydllpath[MAX_PATH];
	char szValue1[2], szValue2[2];
    HKEY hKey;


if(GetRCBool("miniwallstop", TRUE)==FALSE) //check for sos-stop, else use the messagebox way ;)
{
//	if (MessageBox(parentWnd, "This module would like to set up a wallpaper.\nContiniue?", "miniwall.dll", MB_YESNO | MB_SETFOREGROUND) == IDYES)
//	{
	if(GetRCBool("miniwallc", TRUE)==TRUE) //center wall
{
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS)
{
	strcpy(szValue1, "0");
    strcpy(szValue2, "0");
	RegSetValueEx(hKey, "WallpaperStyle", 0, REG_SZ, (unsigned char *)szValue1, strlen(szValue1) + 1);
    RegSetValueEx(hKey, "TileWallpaper", 0, REG_SZ, (unsigned char *)szValue2, strlen(szValue2) + 1);
    RegCloseKey(hKey);
}
}

	if(GetRCBool("miniwallt", TRUE)==TRUE) //tile wall
{
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS)
{
	strcpy(szValue1, "1");
    strcpy(szValue2, "1");
	RegSetValueEx(hKey, "WallpaperStyle", 0, REG_SZ, (unsigned char *)szValue1, strlen(szValue1) + 1);
    RegSetValueEx(hKey, "TileWallpaper", 0, REG_SZ, (unsigned char *)szValue2, strlen(szValue2) + 1);
    RegCloseKey(hKey);
}
}

	if(GetRCBool("miniwalls", TRUE)==TRUE) //strech
{
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Control Panel\\Desktop", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS)
{
	strcpy(szValue1, "2");
    strcpy(szValue2, "0");
	RegSetValueEx(hKey, "WallpaperStyle", 0, REG_SZ, (unsigned char *)szValue1, strlen(szValue1) + 1);
    RegSetValueEx(hKey, "TileWallpaper", 0, REG_SZ, (unsigned char *)szValue2, strlen(szValue2) + 1);
    RegCloseKey(hKey);
}
}
	GetRCLine("miniwallimgpath", mybitmap, MAX_LINE_LENGTH, NULL); //get bmp path
	SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, mybitmap, SPIF_UPDATEINIFILE | SPIF_SENDCHANGE); //put bmp path
//}
}
		
GetRCLine("miniwalldllpath",mytmppath,MAX_PATH,".none");
strcpy(mydllpath,"!unloadmodule ");
strcat(mydllpath,mytmppath);
LSExecute(NULL, mydllpath, NULL);
return code;
}

void quitModule(HINSTANCE dllInst)
{
}